# include <stdio.h>
# include <math.h>

double f(double x)
{
    return x * sin( x * x);
}
double fp(double x)
{
    return sin(x*x)+ x* (2.0 * x) * cos(x * x);
}

double fpfinite(double x)
{
    const double eps = 1e-8;
    return (f(x+eps)-f(x))/eps;
}

void printGradients(double a,double b)
{
    const int points=1000;
    FILE *ft=fopen("gradient.txt","w");
    for(double x=a;x<=b;x+=(b-a)/points)
    {
        fprintf(ft,"%20.10lf %20.10lf %20.10lf\n",x,fp(x),fpfinite(x));
    }
    //print command plot 'gradient.txt' u 1:($3)-($2) w l
    fclose(ft);
}

int main()
{
    const double a= -10;
    const double b=  10;
    printGradients(a,b);
    return 0;
}
