# include <stdio.h>
# include <math.h>

double f(double x)
{
    return x * sin( x * x);
}
double fp(double x)
{
    return sin(x*x)+ x* (2.0 * x) * cos(x * x);
}
double getBolzanoRoot(double a,double b,int &status)
{
    double x= (a+b)/2;
    const int imax=200;
    int it = 0;
    FILE *ft=fopen("bolzano.txt","w");
    while(it<imax)
    {
fprintf(ft,"%lf %lf %lf\n",a,b,f(x));
        if(fabs(f(x))<1e-8) {
            status =1;
            fclose(ft);
            return x;
        }
        else if (f(a)*f(x)<0)
        {
            b =x;
            x = (a+b)/2;
        }
        else
        {
            a=x;
            x=(a+b)/2;
        }

        it++;
    }
    fclose(ft);
    status=0;
    return -1;
}

double getNewtonRoot(double x)
{
    const int imax=200;
    int it = 0;
    FILE *ft=fopen("newton.txt","w");
    while(it<=imax)
    {
        it++;
        if(fabs(f(x))<1e-8) break;
        x = x -f(x)/fp(x);
        fprintf(ft,"%lf %lf\n",x,f(x));
    }
    fclose(ft);
    return x;
}

int main()
{
   int status = 0;
   double a = -5;
   double b = 3;
   double x1 =getBolzanoRoot(a,b,status);
   double x2 = getNewtonRoot(a);
   printf("Roots: %lf %lf \n",x1,x2);
}
