#ifndef DOUBLEEQUATION_H
#define DOUBLEEQUATION_H
# include <math.h>
# include "complex.h"

class DoubleEquation
{
private:
    double eqA,eqB,eqC;
    double realSolution1,realSolution2;
    Complex complexSolution1,complexSolution2;
public:
    DoubleEquation(double A,double B,double C);
    void    Solve();
    void    printSolutions();
    bool    hasSolutons()      const;
    bool    hasRealSolutions() const;
    bool    hasDoubleRoot()    const;
    bool    hasComplexRoots()  const;
    void    getRealSolutions(double &a,double &b) const;
    void    getComplexSolutions(Complex &a,Complex &b) const;
    ~DoubleEquation();
};

#endif // DOUBLEEQUATION_H
